# class SS7MTP2 | SS7 Layer 2 implementation on top of a hardware interface. More...
Full name | `TelEngine::SS7MTP2`
Definition | `#include <libs/ysig/yatesig.h>`
Inherits | TelEngine::Mutex [public ], TelEngine::SS7Layer2 [public ], TelEngine::SignallingDumpable [public ], TelEngine::SignallingReceiver [public ]
List of all Methods
Annotated List
Files
Globals
Hierarchy
Index

#### Public Types

- enum ErrorCorrection { Basic, Preventive, Adaptive, }

#### Public Methods

- SS7MTP2 (const NamedList& params, unsigned int status = OutOfService)
- virtual ~SS7MTP2 ()
- virtual bool initialize (const NamedList* config)
- virtual bool transmitMSU (const SS7MSU& msu)
- virtual void recoverMSU (int sequence)
- virtual unsigned int status () const
- virtual bool aligned () const
- virtual bool operational () const
- virtual bool control (Operation oper, NamedList* params = 0)
- virtual bool notify (SignallingInterface::Notification event)

#### Protected Methods

- virtual void destroyed ()
- virtual void timerTick (const Time& when)
- virtual bool receivedPacket (const DataBlock& packet)
- virtual void processFISU ()
- virtual void processLSSU (unsigned int status)
- bool transmitLSSU (unsigned int status)
- inline bool transmitLSSU ()
- bool transmitFISU ()
- void startAlignment (bool emergency = false)
- void abortAlignment (bool retry = true)
- bool startProving ()

## Detailed Description

Q.703 SS7 Layer 2 (Data Link) implementation on top of a hardware interface

enum ErrorCorrection { Basic, Preventive, Adaptive, } | ### ErrorCorrection

Types of error correction

SS7MTP2 (const NamedList& params, unsigned int status = OutOfService) | ### SS7MTP2

Constructor

Parameters:

params | Layer's parameters
status | Initial status

~SS7MTP2 () | ### ~SS7MTP2

[virtual]

Destructor

bool initialize (const NamedList* config) | ### initialize

[virtual]

Configure and initialize MTP2 and its interface

Parameters:

config | Optional configuration parameters override

Returns: True if MTP2 and the interface were initialized properly

Reimplemented from SignallingComponent.

bool transmitMSU (const SS7MSU& msu) | ### transmitMSU

[virtual]

Push a Message Signal Unit down the protocol stack

Parameters:

msu | MSU data to transmit

Returns: True if message was successfully queued

Reimplemented from SS7Layer2.

void recoverMSU (int sequence) | ### recoverMSU

[virtual]

Remove the MSUs waiting in the transmit queue and return them

Parameters:

sequence | First sequence number to recover, flush earlier packets

Reimplemented from SS7Layer2.

unsigned int status () | ### status

[const virtual]

Retrieve the current link status indications

Returns: Link status indication bits

Reimplemented from SS7Layer2.

bool aligned () | ### aligned

[const virtual]

Check if the link is aligned. The link may not be operational, the other side may be still proving.

Returns: True if the link is aligned

bool operational () | ### operational

[const virtual]

Check if the link is aligned and operational

Returns: True if the link is operational

Reimplemented from SS7Layer2.

bool control (Operation oper, NamedList* params = 0) | ### control

[virtual]

Execute a control operation. Operations can change the link status or can query the aligned status.

Parameters:

oper | Operation to execute
params | Optional parameters for the operation

Returns: True if the command completed successfully, for query operations also indicates the data link is aligned and operational

Reimplemented from SS7Layer2.

bool notify (SignallingInterface::Notification event) | ### notify

[virtual]

Process a notification generated by the attached interface

Parameters:

event | Notification event reported by the interface

Returns: True if notification was processed

Reimplemented from SS7Layer2.

void destroyed () | ### destroyed

[protected virtual]

Remove all attachements. Disposes the memory

Reimplemented from SignallingComponent.

void timerTick (const Time& when) | ### timerTick

[protected virtual]

Periodical timer tick used to perform alignment and housekeeping

Parameters:

when | Time to use as computing base for events and timeouts

Reimplemented from SS7Layer2.

bool receivedPacket (const DataBlock& packet) | ### receivedPacket

[protected virtual]

Process a Signalling Packet received by the hardware interface

Returns: True if message was successfully processed

Reimplemented from SignallingReceiver.

void processFISU () | ### processFISU

[protected virtual]

Process a received Fill-In Signal Unit

void processLSSU (unsigned int status) | ### processLSSU

[protected virtual]

Process a received Link Status Signal Unit

Parameters:

status | Link status indications

bool transmitLSSU (unsigned int status) | ### transmitLSSU

[protected]

Push a Link Status Signal Unit down the protocol stack

Parameters:

status | Link status indications

Returns: True if message was successfully queued

inline bool transmitLSSU () | ### transmitLSSU

[protected]

Push a Link Status Signal Unit with the current status down the protocol stack

Returns: True if message was successfully queued

bool transmitFISU () | ### transmitFISU

[protected]

Push a Fill-In Signal Unit down the protocol stack

Returns: True if message was successfully queued

void startAlignment (bool emergency = false) | ### startAlignment

[protected]

Initiates alignment and proving procedure

Parameters:

emergency | True if emergency alignment is desired

void abortAlignment (bool retry = true) | ### abortAlignment

[protected]

Abort an alignment procedure if link errors occur

Parameters:

retry | Keep trying to align

bool startProving () | ### startProving

[protected]

Start the link proving period

Returns: True if proving period was started

Generated by: paulc on bussard on Mon Feb 10 13:15:47 2014, using kdoc 2.0a54.